#pragma once

namespace f8
{
    struct DynModuleState
    {
        bool pending = false;
        bool data_is_valid = false;;
    };

    class DynModule
    {
    public:
        DynModule();
        ~DynModule();
        virtual bool IsDataMsg(int msgid);
        bool IsPending();
        bool DataIsValid();
        void MarkDataValid();
        void MarkPending();
        void CancelPending();

    private:
        DynModuleState module_state_;
    };

}

