#include <a8/a8.h>

#include <google/protobuf/message.h>
#include <google/protobuf/descriptor.h>

#include <f8/f8.h>
#include <f8/udplog.h>
#include <f8/utils.h>
#include <f8/protoutils.h>
#include <f8/netmsghandler.h>

namespace f8
{

    NetMsgHandler* GetNetMsgHandler(NetMsgHandlerObject* handlers,
                                    unsigned short msgid)
    {
        return msgid < MAX_MSG_ID ? handlers->handlers[msgid] : nullptr;
    }

    void DumpMsgToLog(f8::MsgHdr& hdr, f8::NetMsgHandler* handler, const char* prefix)
    {
        return;
        ::google::protobuf::Message* msg = handler->prototype->New();
        bool ok = msg->ParseFromArray(hdr.buf + hdr.offset, hdr.buflen - hdr.offset);
        f8::UdpLog::Instance()->Debug
            (
             "%s%s %s",
             {
              prefix,
              msg->GetTypeName(),
              f8::PbToJson(msg)
             });
        delete msg;
    }

    void DumpMsgToLog(const ::google::protobuf::Message& msg, const char* prefix)
    {
        return;
        f8::UdpLog::Instance()->Debug
            (
             "%s%s %s",
             {
              prefix,
              msg.GetTypeName(),
              f8::PbToJson(&msg)
             });
    }

}
