#pragma once

namespace a8
{
    class MutableXObject;
}

class Player;
namespace f8
{
    struct JsonHttpRequest
    {
        bool pending = false;
        unsigned long saddr = 0;
        int socket_handle = 0;
        time_t create_time = 0;
        time_t handle_time = 0;
        std::string query_str;
        a8::XObject request;
        a8::MutableXObject* resp_xobj = nullptr;

        int async_pending_count = 0;
        void* context = nullptr;
        void (*free_context)(void*) = nullptr;

        JsonHttpRequest();
        ~JsonHttpRequest();
        std::string Response();
    };

    enum SysInnerMesssage_e
    {
        IM_SysBegin = 1,
        IM_SysMsgQueue = 2,
        IM_SysEnd = 99,
    };

    struct MsgHdr
    {
        unsigned int seqid;
        unsigned short msgid;
        int socket_handle;
        unsigned long ip_saddr;
        const char* buf;
        int buflen;
        int offset;
        Player *hum = nullptr;
        const void* user_data = nullptr;

        MsgHdr* Clone();
        static void Destroy(MsgHdr* hdr);
    };

}
